package org.dromara.zjk.service;


import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.zjk.domain.bo.ZjkLeaveBo;
import org.dromara.zjk.domain.vo.StsLeaveVO;
import org.dromara.zjk.domain.vo.StsNumVO;
import org.dromara.zjk.domain.vo.ZjkEvaluateVO;
import org.dromara.zjk.domain.vo.ZjkLeaveVo;

import java.util.Collection;
import java.util.List;

/**
 * 【请填写功能名称】Service接口
 *
 * @author ygh
 * @date 2024-10-30
 */
public interface IZjkLeaveService {

    /**
     * 查询【请填写功能名称】
     *
     * @param gid 主键
     * @return 【请填写功能名称】
     */
    ZjkLeaveVo queryById(String gid);

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    TableDataInfo<ZjkLeaveVo> queryPageList(ZjkLeaveBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    List<ZjkLeaveVo> queryList(ZjkLeaveBo bo);

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    R<Void> insertByBo(ZjkLeaveBo bo);

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    Boolean updateByBo(ZjkLeaveBo bo);

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid);

    TableDataInfo<ZjkLeaveVo> queryPageSpList(ZjkLeaveBo bo, PageQuery pageQuery);

    TableDataInfo<ZjkLeaveVo> queryAdminPageList(ZjkLeaveBo bo, PageQuery pageQuery);

    R<StsNumVO> getStsNum();

    TableDataInfo<ZjkEvaluateVO> getLeavePros();

    R<Void> leaveForPro(ZjkEvaluateVO vo);

    R<Void> setAccept(ZjkEvaluateVO bo);

    R<StsLeaveVO> getStsChart(Integer rangeMonth);

    TableDataInfo<ZjkEvaluateVO> getProsForAccept();

    TableDataInfo<ZjkEvaluateVO> getProsForJoin();
}
